## tiup 1.16.3

=== Makefile ===
.PHONY: components server targets
.DEFAULT_GOAL := default

LANG=C
MAKEOVERRIDES =
targets:
	@printf "%-30s %s\n" "Target" "Description"
	@printf "%-30s %s\n" "------" "-----------"
	@make -pqR : 2>/dev/null \
	| awk -v RS= -F: '/^# File/,/^# Finished Make data base/ {if ($$1 !~ "^[#.]") {print $$1}}' \
	| egrep -v -e '^[^[:alnum:]]' -e '^$@$$' \
	| sort \
	| xargs -I _ sh -c 'printf "%-30s " _; make _ -nB | (grep "^# Target:" || echo "") | tail -1 | sed "s/^# Target: //g"'

REPO    := github.com/pingcap/tiup

GOOS    := $(if $(GOOS),$(GOOS),$(shell go env GOOS))
GOARCH  := $(if $(GOARCH),$(GOARCH),$(shell go env GOARCH))
GOENV   := GO111MODULE=on CGO_ENABLED=0 GOOS=$(GOOS) GOARCH=$(GOARCH)
GO      := $(GOENV) go
GOBUILD := $(GO) build $(BUILD_FLAGS)
GOINSTALL := $(GO) install
GOTEST  := GO111MODULE=on CGO_ENABLED=1 go test -p 3
SHELL   := /usr/bin/env bash

_COMMIT := $(shell git describe --no-match --always --dirty)
_GITREF := $(shell git rev-parse --abbrev-ref HEAD)
COMMIT  := $(if $(COMMIT),$(COMMIT),$(_COMMIT))
GITREF  := $(if $(GITREF),$(GITREF),$(_GITREF))

LDFLAGS := -w -s
LDFLAGS += -X "$(REPO)/pkg/version.GitHash=$(COMMIT)"
LDFLAGS += -X "$(REPO)/pkg/version.GitRef=$(GITREF)"
LDFLAGS += $(EXTRA_LDFLAGS)

FILES   := $$(find . -name "*.go")

FAILPOINT_ENABLE  := $$(go tool github.com/pingcap/failpoint/failpoint-ctl enable)
FAILPOINT_DISABLE := $$(go tool github.com/pingcap/failpoint/failpoint-ctl disable)

default: check build
	@# Target: run the checks and then build.

include ./tests/Makefile

# Build TiUP and all components
build: tiup components
	@# Target: build tiup and all it's components

components: playground client cluster dm server
	@# Target: build the playground, client, cluster, dm and server components

tiup:
	@# Target: build the tiup driver
	$(GOBUILD) -ldflags '$(LDFLAGS)' -o bin/tiup

playground:
	@# Target: build tiup-playground component
	$(GOBUILD) -ldflags '$(LDFLAGS)' -o bin/tiup-playground ./components/playground

client:
	@# Target: build the tiup-client component
	$(MAKE) -C components/client $(MAKECMDGOALS)

cluster:
	@# Target: build the tiup-cluster component
	$(GOBUILD) -ldflags '$(LDFLAGS)' -o bin/tiup-cluster ./components/cluster

dm:
	@# Target: build the tiup-dm component
	$(GOBUILD) -ldflags '$(LDFLAGS)' -o bin/tiup-dm ./components/dm

ctl:
	@# Target: build the tiup-ctl component
	$(GOBUILD) -ldflags '$(LDFLAGS)' -o bin/tiup-ctl ./components/ctl

server:
	@# Target: build the tiup-server component
	$(GOBUILD) -ldflags '$(LDFLAGS)' -o bin/tiup-server ./server

check: fmt lint tidy check-static vet
	@# Target: run all checkers. (fmt, lint, tidy, check-static and vet)
	$(MAKE) -C components/client ${MAKECMDGOALS}

check-static: tools/bin/golangci-lint
	@# Target: run the golangci-lint static check tool
	tools/bin/golangci-lint run --config tools/check/golangci.yaml ./... --timeout=3m --fix

lint:
	@# Target: run the lint checker revive
	@echo "linting"
	@go tool github.com/mgechev/revive -formatter friendly -config tools/check/revive.toml $(FILES)

vet:
	@# Target: run the go vet tool
	$(GO) vet ./...

tidy:
	@# Target: run tidy check
	@echo "go mod tidy"
	./tools/check/check-tidy.sh

clean:
	@# Target: run the build cleanup steps
	@rm -rf bin
	@rm -rf cover
	@rm -rf tests/*/{bin/*.test,logs,cover/*.out}

test: failpoint-enable run-tests failpoint-disable
	@# Target: run tests with failpoint enabled
	$(MAKE) -C components/client ${MAKECMDGOALS}

# TODO: refactor integration tests base on v1 manifest
# run-tests: unit-test integration_test
run-tests: unit-test
	@# Target: run the unit tests

# Run tests
unit-test:
	@# Target: run the code coverage test phase
	mkdir -p cover
	TIUP_HOME=$(shell pwd)/tests/tiup $(GOTEST) ./... -covermode=count -coverprofile cover/cov.unit-test.out

race: failpoint-enable
	@# Target: run race check with failpoint enabled
	TIUP_HOME=$(shell pwd)/tests/tiup $(GOTEST) -race ./...  || { $(FAILPOINT_DISABLE); exit 1; }
	@$(FAILPOINT_DISABLE)

failpoint-enable:
	@# Target: enable failpoint
	@$(FAILPOINT_ENABLE)

failpoint-disable:
	@# Target: disable failpoint
	@$(FAILPOINT_DISABLE)

fmt:
	@# Target: run the go formatter utility
	@echo "gofmt (simplify)"
	@gofmt -s -l -w $(FILES) 2>&1
	@echo "goimports (if installed)"
	$(shell goimports -w $(FILES) 2>/dev/null)

tools/bin/golangci-lint:
	@# Target: pull in specific version of golangci-lint (v1.64.8)
	curl -sfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b ./tools/bin v1.64.8

=== components/client/Makefile ===
.DEFAULT_GOAL := default

LANG=C
MAKEOVERRIDES =
targets:
	@printf "%-30s %s\n" "Target" "Description"
	@printf "%-30s %s\n" "------" "-----------"
	@make -pqR : 2>/dev/null \
	| awk -v RS= -F: '/^# File/,/^# Finished Make data base/ {if ($$1 !~ "^[#.]") {print $$1}}' \
	| egrep -v -e '^[^[:alnum:]]' -e '^$@$$' \
	| sort \
	| xargs -I _ sh -c 'printf "%-30s " _; make _ -nB | (grep "^# Target:" || echo "") | tail -1 | sed "s/^# Target: //g"'

REPO    := github.com/pingcap/tiup

GOOS    := $(if $(GOOS),$(GOOS),$(shell go env GOOS))
GOARCH  := $(if $(GOARCH),$(GOARCH),$(shell go env GOARCH))
GOENV   := GO111MODULE=on CGO_ENABLED=0 GOOS=$(GOOS) GOARCH=$(GOARCH)
GO      := $(GOENV) go
GOBUILD := $(GO) build $(BUILD_FLAGS)
GOTEST  := GO111MODULE=on CGO_ENABLED=1 go test -p 3
SHELL   := /usr/bin/env bash

_COMMIT := $(shell git describe --no-match --always --dirty)
_GITREF := $(shell git rev-parse --abbrev-ref HEAD)
COMMIT  := $(if $(COMMIT),$(COMMIT),$(_COMMIT))
GITREF  := $(if $(GITREF),$(GITREF),$(_GITREF))

LDFLAGS := -w -s
LDFLAGS += -X "$(REPO)/pkg/version.GitHash=$(COMMIT)"
LDFLAGS += -X "$(REPO)/pkg/version.GitRef=$(GITREF)"
LDFLAGS += $(EXTRA_LDFLAGS)

FILES   := $$(find . -name "*.go")

FAILPOINT_ENABLE  := $$(go tool github.com/pingcap/failpoint/failpoint-ctl enable)
FAILPOINT_DISABLE := $$(go tool github.com/pingcap/failpoint/failpoint-ctl disable)

default: check build
	@# Target: run the checks and then build.

include ../../tests/Makefile

# Build components
build: components
	@# Target: build tiup and all it's components

components: client
	@# Target: build the playground, client, cluster, dm and server components

client:
	@# Target: build the tiup-client component
	$(GOBUILD) -ldflags '$(LDFLAGS)' -o ../../bin/tiup-client .

check: fmt lint check-static vet
	@# Target: run all checkers. (fmt, lint, check-static and vet)

check-static:
	@# Target: run the golangci-lint static check tool
	../../tools/bin/golangci-lint run --config ../../tools/check/golangci.yaml ./... --timeout=3m --fix

lint:
	@# Target: run the lint checker revive
	@echo "linting"
	@go tool github.com/mgechev/revive -formatter friendly -config ../../tools/check/revive.toml $(FILES)

vet:
	@# Target: run the go vet tool
	$(GO) vet ./...

clean:
	@# Target: run the build cleanup steps
	@rm -rf bin
	@rm -rf tests/*/{bin/*.test,logs}

test: failpoint-enable run-tests failpoint-disable
	@# Target: run tests with failpoint enabled

# TODO: refactor integration tests base on v1 manifest
# run-tests: unit-test integration_test
run-tests: unit-test
	@# Target: run the unit tests

# Run tests
unit-test:
	@# Target: run the code coverage test phase
	mkdir -p ../../cover
	TIUP_HOME=$(shell pwd)/../../tests/tiup $(GOTEST) ./... -covermode=count -coverprofile ../../cover/cov.unit-test.client.out

race: failpoint-enable
	@# Target: run race check with failpoint enabled
	TIUP_HOME=$(shell pwd)/../../tests/tiup $(GOTEST) -race ./...  || { $(FAILPOINT_DISABLE); exit 1; }
	@$(FAILPOINT_DISABLE)

failpoint-enable:
	@# Target: enable failpoint
	@$(FAILPOINT_ENABLE)

failpoint-disable:
	@# Target: disable failpoint
	@$(FAILPOINT_DISABLE)

fmt:
	@# Target: run the go formatter utility
	@echo "gofmt (simplify)"
	@gofmt -s -l -w $(FILES) 2>&1
	@echo "goimports (if installed)"
	$(shell goimports -w $(FILES) 2>/dev/null)

=== debian/changelog ===
tiup (1.16.3-1) unstable; urgency=medium

  * Initial release (Closes: #1107484)

 -- Otto Kekäläinen <otto@debian.org>  Wed, 19 Mar 2025 23:31:49 +0000

=== debian/control ===
Source: tiup
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Otto Kekäläinen <otto@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-golang,
 dh-sequence-golang,
 golang-any,
 golang-etcd-server-dev,
 golang-github-alecthomas-chroma-dev,
 golang-github-asaskevich-eventbus-dev,
 golang-github-astroprofundis-sysinfo-dev,
 golang-github-cavaliergopher-grab-dev,
 golang-github-cheggaaa-pb.v3-dev,
 golang-github-creasty-defaults-dev,
 golang-github-dchest-bcrypt-pbkdf-dev,
 golang-github-docker-go-units-dev,
 golang-github-fatih-color-dev,
 golang-github-gibson042-canonicaljson-go-dev,
 golang-github-gizak-termui-dev,
 golang-github-go-git-go-billy-dev,
 golang-github-go-sql-driver-mysql-dev,
 golang-github-gofrs-flock-dev,
 golang-github-golang-protobuf-1-5-dev,
 golang-github-google-shlex-dev,
 golang-github-google-uuid-dev,
 golang-github-gorilla-mux-dev,
 golang-github-jedib0t-go-pretty-dev,
 golang-github-jeremywohl-flatten-dev,
 golang-github-joomcode-errorx-dev,
 golang-github-lorenzosaino-go-sysctl-dev,
 golang-github-mattn-go-runewidth-dev,
 golang-github-mattn-go-sixel-dev,
 golang-github-minio-minio-go-v7-dev,
 golang-github-mitchellh-colorstring-dev,
 golang-github-pingcap-errors-dev,
 golang-github-pingcap-fn-dev,
 golang-github-pingcap-kvproto-dev,
 golang-github-pkg-errors-dev,
 golang-github-prometheus-client-model-dev,
 golang-github-prometheus-common-dev,
 golang-github-prometheus-prom2json-dev,
 golang-github-r3labs-diff-dev,
 golang-github-relex-aini-dev,
 golang-github-scaleft-sshkeys-dev,
 golang-github-sergi-go-diff-dev,
 golang-github-sethvargo-go-password-dev,
 golang-github-shirou-gopsutil-dev,
 golang-github-spf13-cobra-dev,
 golang-github-spf13-pflag-dev,
 golang-github-stretchr-testify-dev,
 golang-github-vishvananda-netlink-dev,
 golang-github-xo-dburl-dev,
 golang-github-xo-tblfmt-dev,
 golang-github-xo-terminfo-dev,
 golang-go.uber-atomic-dev,
 golang-go.uber-zap-dev,
 golang-golang-x-crypto-dev,
 golang-golang-x-mod-dev,
 golang-golang-x-sync-dev,
 golang-golang-x-sys-dev,
 golang-golang-x-term-dev,
 golang-google-grpc-dev,
 golang-gopkg-ini.v1-dev,
 golang-gopkg-vmihailenco-msgpack.v2-dev,
 golang-gopkg-yaml.v3-dev,
 golang-sslmate-src-go-pkcs12-dev,
 golang-toml-dev,
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/tiup
Vcs-Git: https://salsa.debian.org/go-team/packages/tiup.git
Homepage: https://github.com/pingcap/tiup
XS-Go-Import-Path: github.com/pingcap/tiup

Package: tiup
Section: utils
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Static-Built-Using:
 ${misc:Static-Built-Using},
Built-Using:
 ${misc:Built-Using},
Description: Component manager for TiDB
 TiUP is a tool designed to manage TiDB components, providing an easy way to
 install, update, and maintain various components of the TiDB ecosystem. It
 simplifies the process of setting up and managing TiDB clusters, making it
 accessible for both developers and administrators. With TiUP, you can quickly
 deploy and scale TiDB clusters, ensuring high availability and performance.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

# Generic hardening of binaries
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export DH_GOLANG_INSTALL_EXTRA := embed/examples/ embed/templates/

override_dh_auto_test:
	@echo "Skipping post-build Go tests because of too many failures"

override_dh_auto_install:
	dh_auto_install -- --no-source
	(cd debian/tiup/usr/bin/ && for x in *; do mv $$x tiup-$$x; done; mv tiup-tiup tiup)

%:
	dh $@ --builddirectory=debian/_build/upstream --buildsystem=golang

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/" \
  https://github.com/pingcap/tiup/tags .*/v?(\d\S*)\.tar\.gz debian

## tiup 1.16.4

=== tests/Makefile ===
build_integration_test: build_tiup_playground_test build_tiup_cluster_test build_tiup_dm_test
	@# Target: run the playground, cluster, and dm integration tests.

build_tiup_playground_test: failpoint-enable
	@# Target: run the tiup-playground tests
	$(GOTEST) -c -cover -covermode=count \
		-coverpkg=github.com/pingcap/tiup/... \
		-o tests/tiup-playground/bin/tiup-playground.test \
		github.com/pingcap/tiup/components/playground
	@$(FAILPOINT_DISABLE)

build_tiup_cluster_test: failpoint-enable
	@# Target: run the tiup-cluster tests
	$(GOTEST) -c -cover -covermode=count \
		-coverpkg=github.com/pingcap/tiup/... \
		-o tests/tiup-cluster/bin/tiup-cluster.test \
		github.com/pingcap/tiup/components/cluster;
	@$(FAILPOINT_DISABLE)

build_tiup_dm_test: failpoint-enable
	@# Target: run the tiup-dm tests
	$(GOTEST) -c -cover -covermode=count \
		-coverpkg=github.com/pingcap/tiup/... \
		-o tests/tiup-dm/bin/tiup-dm.test \
		github.com/pingcap/tiup/components/dm;
	@$(FAILPOINT_DISABLE)

build_tiup_test: failpoint-enable
	@# Target: run the tiup tests
	$(GOTEST) -c -cover -covermode=count \
		-coverpkg=github.com/pingcap/tiup/... \
		-o tests/tiup/bin/tiup.test \
		github.com/pingcap/tiup;
	@$(FAILPOINT_DISABLE)

=== debian/changelog ===
tiup (1.16.4-1) unstable; urgency=medium

  * New upstream release
  * Remove multiple patches that limited TiUP functionality and dependencies
    intentionally when multiple packages were pending in the NEW queue in
    parallel, as they have all been accepted into Debian now and TiUP can be
    built with full functionality
  * Remove unused build dependencies identified by dh-make-golang
  * Drop redundant `Priority: optional`
  * Bump Debian Policy version to 4.7.3
  * Update copyright years for recent contributors
  * Update d/watch to use uscan v5 format
  * Update Lintian overrides about spelling errors in binaries

 -- Otto Kekäläinen <otto@debian.org>  Fri, 27 Feb 2026 08:08:08 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: tiup
 Section: golang
-Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders:
  Otto Kekäläinen <otto@debian.org>,
@@ -10,13 +9,12 @@
  dh-sequence-golang,
  golang-any,
  golang-etcd-server-dev,
- golang-github-alecthomas-chroma-dev,
+ golang-github-appleboy-easyssh-proxy-dev,
  golang-github-asaskevich-eventbus-dev,
  golang-github-astroprofundis-sysinfo-dev,
  golang-github-cavaliergopher-grab-dev,
  golang-github-cheggaaa-pb.v3-dev,
  golang-github-creasty-defaults-dev,
- golang-github-dchest-bcrypt-pbkdf-dev,
  golang-github-docker-go-units-dev,
  golang-github-fatih-color-dev,
  golang-github-gibson042-canonicaljson-go-dev,
@@ -24,8 +22,6 @@
  golang-github-go-git-go-billy-dev,
  golang-github-go-sql-driver-mysql-dev,
  golang-github-gofrs-flock-dev,
- golang-github-golang-protobuf-1-5-dev,
- golang-github-google-shlex-dev,
  golang-github-google-uuid-dev,
  golang-github-gorilla-mux-dev,
  golang-github-jedib0t-go-pretty-dev,
@@ -37,9 +33,9 @@
  golang-github-minio-minio-go-v7-dev,
  golang-github-mitchellh-colorstring-dev,
  golang-github-pingcap-errors-dev,
+ golang-github-pingcap-failpoint-dev,
  golang-github-pingcap-fn-dev,
  golang-github-pingcap-kvproto-dev,
- golang-github-pkg-errors-dev,
  golang-github-prometheus-client-model-dev,
  golang-github-prometheus-common-dev,
  golang-github-prometheus-prom2json-dev,
@@ -55,22 +51,16 @@
  golang-github-vishvananda-netlink-dev,
  golang-github-xo-dburl-dev,
  golang-github-xo-tblfmt-dev,
- golang-github-xo-terminfo-dev,
+ golang-github-xo-usql-dev,
  golang-go.uber-atomic-dev,
  golang-go.uber-zap-dev,
- golang-golang-x-crypto-dev,
- golang-golang-x-mod-dev,
- golang-golang-x-sync-dev,
- golang-golang-x-sys-dev,
- golang-golang-x-term-dev,
- golang-google-grpc-dev,
+ golang-gogoprotobuf-dev,
  golang-gopkg-ini.v1-dev,
- golang-gopkg-vmihailenco-msgpack.v2-dev,
  golang-gopkg-yaml.v3-dev,
  golang-sslmate-src-go-pkcs12-dev,
  golang-toml-dev,
 Testsuite: autopkgtest-pkg-go
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/go-team/packages/tiup
 Vcs-Git: https://salsa.debian.org/go-team/packages/tiup.git
 Homepage: https://github.com/pingcap/tiup

=== debian/watch ===
Version: 5
Template: GitHub
Dist: github.com/pingcap/tiup
Uversion-Mangle: auto
# Use Uversion-Mangle to ensure that e.g. v1.6.0-dev is converted to 1.6.0~dev
# (with tilde) is considered an earlier version than the actual v1.6.0 release
